#include <stdio.h>
// TOTAL is the total width of a character
// RATIO is the ratio between narrow and wide lines
// FUDGE is a fudge factor making black bars narrower so ink bleed is
// less of a problem
#define TOTAL 1000.0
#define RATIO 3.0

#define NARROW ((TOTAL)/(7.0 + RATIO*3.0))
#define ROUND(x) ((int) ((x) + 0.5))
#define FUDGE (NARROW*0.5)

main() {
	FILE *tfp, *ofp;
	int i;
	
	tfp = fopen("code39.tsv", "r");
	ofp = fopen("code39.out", "w");
	do {
		int bar[9], i;
		float left, right;
		unsigned char letter;
		int value, index;
		fscanf(tfp, "%d %c %d %d %d %d %d %d %d %d %d", &value, &letter,
			   &bar[0], &bar[1], &bar[2], &bar[3],
			   &bar[4], &bar[5], &bar[6], &bar[7], &bar[8]);

		fprintf(ofp, "%d <%c>\n", letter, letter);
		left = 0.0;
		for (i = 0; i < 9; i += 2) {
			int lint, rint;
			right = left + NARROW*(1.0 + (RATIO-1.0)*bar[i]);

			lint = ROUND(left);
			rint = ROUND(right - FUDGE);

			fprintf(ofp, "%d %d m 1 %d %d l 1 %d %d l 1 %d %d l 1 %d %d l 1\n",
					lint, 0,
					lint, 1000,
					rint, 1000,
					rint, 0,
					lint, 0);

			if (i < 8)
			    left = right + NARROW*(1.0 + (RATIO-1.0)*bar[i+1]);
		}
	} while (!feof(tfp));

	return 0;
}


	
